//ProjektName:  Zylinder drehen
//Autor: IFlo
//Beschreibung: Erstellung eines

//Dies ist ein Grundgerst fr OpenGL Anwendungen ohne die VCL.
//In dieser *.dpr-Datei brauch normalerweise nichts gendert werden.
//Nur smtliche Units sollten in der uses Klauses aufgelistet sein.
//Euer IFlo





program OpenGLProjekt;

uses
  Windows,
  Messages,
  OpenGL12,
  FensterVerwaltung in 'Units\FensterVerwaltung.pas',
  MessageControlUnit in 'Units\MessageControlUnit.pas',
  GlobaleVariablen in 'Units\GlobaleVariablen.pas',
  RenderUnit in 'Units\RenderUnit.pas',
  BerechnungsUnit in 'Units\BerechnungsUnit.pas';

{$R *.RES}


{------------------------------------------------------------------}
{  Initialisierung von OpenGL                                      }
{------------------------------------------------------------------}
procedure glInit();
begin
  glEnable(GL_TEXTURE_2D);	       // Aktiviert Texture Mapping
  glShadeModel(GL_SMOOTH);	       // Aktiviert weiches Shading
  glClearColor(0.0, 0.0, 0.0, 0.5);    // Bildschirm lschen (schwarz)
  glClearDepth(1.0);		       // Depth Buffer Setup
  glEnable(GL_DEPTH_TEST);	       // Aktiviert Depth Testing
  glDepthFunc(GL_LEQUAL);	       // Bestimmt den Typ des Depth Testing
  glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
                                         // Qualitativ bessere Koordinaten Interpolation
end;

{--------------------------------------------------------------------}
{  Main message loop for the application                             }
{--------------------------------------------------------------------}
function WinMain(hInstance : HINST; hPrevInstance : HINST;
                 lpCmdLine : PChar; nCmdShow : Integer) : Integer; stdcall;
var
  msg : TMsg;
  appStart : DWord;
begin
  Finished := False;
  InitOpenGL;
  {Erstellung des Fensters}
  glWindow := TGLWindow.Create(800,600,false);
  if glWindow.Fullscreen then glResizeWnd(800,600);//Fenster im Vollbildmodus erhalten keine Resize-Message
  {Zeit}
  SetTimer(glWindow.Handle,FPS_TIMER,FPS_INTERVAL,nil);
  appStart := GetTickCount();            // Die Zeit zum Programmstart nehmen
  BerechnungsZeit := GetTickCount();
  // Main message loop:
  while not finished do
  begin
    if (PeekMessage(msg, 0, 0, 0, PM_REMOVE)) then // Nach Windows-Messages suchen
    begin
      if (msg.message = WM_QUIT) then     // Falls WM_QUIT dabei ist sind wir fertig
        finished := True
      else
      begin                               // Ansonsten wird die Message an das Programm weitergegeben
  	TranslateMessage(msg);
        DispatchMessage(msg);
      end;
    end
    else
    begin
      Inc(FPSCount);                      // FPS Zhler erhhen
      ElapsedTime := GetTickCount() - appStart;     // Programmlaufzeit berechnen

      BerechnungsCheck;
      Render ;// Szene zeichnen
      SwapBuffers(glWindow.DC);                  // Szene ausgeben

      if (keys[VK_ESCAPE]) then finished := true;                      // Tastatureingaben verarbeiten
      //Berechne;//Nur vorlufig hier
    end;
  end;
  glWindow.Free; //glKillWnd(FALSE);
  glWindow := nil;
  Result := msg.wParam;
end;




begin
WinMain( hInstance, hPrevInst, CmdLine, CmdShow );

end.
