unit MessageControlUnit;

interface
uses Windows,Messages,GlobaleVariablen,RenderUnit,sysutils;
function WndProc(hWnd: HWND; Msg: UINT;  wParam: WPARAM;  lParam: LPARAM): LRESULT; stdcall;
implementation
{------------------------------------------------------------------------------}
{  Message-Behandlung des Programs festlegen                                   }
{------------------------------------------------------------------------------}
function WndProc(hWnd: HWND; Msg: UINT;  wParam: WPARAM;  lParam: LPARAM): LRESULT; stdcall;
begin
  case (Msg) of
    WM_CREATE:
      begin
      // ByWMCreate;
      end;
    WM_CLOSE:
      begin
        PostQuitMessage(0);
        Result := 0
      end;
    WM_KEYDOWN:       // Taste als 'pressed' markieren
      begin
        keys[wParam] := True;
        Result := 0;
      end;
    WM_KEYUP:         // Taste als 'up' markieren
      begin
        keys[wParam] := False;
        Result := 0;
      end;
    WM_SIZE:          // Gre anpassen
      begin
        glResizeWnd(LOWORD(lParam),HIWORD(lParam));
        Result := 0;
      end;
    WM_TIMER :                     // Hier werden alle benutzten Timer behandelt
      begin
        case  wParam of
         FPS_TIMER:
          begin
            FPSCount :=Round(FPSCount * 1000/FPS_INTERVAL);   // FPS berechnen...
            SetWindowText(glWindow.Handle, PChar(WND_TITLE + '   [' + IntToStr(FPSCount) + ' FPS]')); //... und ausgeben!
            FPSCount := 0;
            Result := 0;
          end;
        end;
      end;
    else
      Result := DefWindowProc(hWnd, Msg, wParam, lParam);    //  Standard-Behandlung aller anderen Messages
  end;
end;

end.
